#version 130
#extension GL_EXT_gpu_shader4 : enable
// the version and open GL extension
// should be the first line of the shader
/////////////////////////////////////////////////////////////////////////////////
//Fiery Glowing Dragon ScalesMod01.fsh   by  johnowhitaker  
//https://www.shadertoy.com/view/flGSDD
// Licence CC0
// Adapted, trivialy, for use in VGHD player
/////////////////////////////////////////////
uniform float u_Elapsed;    // The elapsed time in seconds
uniform vec2  u_WindowSize; // Window dimensions in pixels

#define iTime u_Elapsed*0.314159  //*0.1666
#define iResolution u_WindowSize

//#define mouse AUTO_MOUSE
//#define MOUSE_SPEED vec2(vec2(0.5,0.577777) * 0.25)
//#define MOUSE_POS   vec2((1.0+cos(iTime*MOUSE_SPEED))*u_WindowSize/2.0)
//#define MOUSE_PRESS vec2(0.0,0.0)
//#define AUTO_MOUSE  vec4( MOUSE_POS, MOUSE_PRESS )
//#define RIGID_SCROLL
// alternatively use static mouse definition
#define iMouse vec4(0.0,0.0, 0.0,0.0)
//#define iMouse vec4(512,256,180,120)
uniform sampler2D iChannel0;
uniform sampler2D iChannel1;
uniform sampler2D iChannel2;
uniform sampler2D iChannel3;
vec4 texture2D_Fract(sampler2D sampler,vec2 P) {return texture2D(sampler,fract(P));}
vec4 texture2D_Fract(sampler2D sampler,vec2 P, float Bias) {return texture2D(sampler,fract(P),Bias);}
#define texture2D texture2D_Fract

//void mainImage( out vec4 fragColor, in vec2 fragCoord )
///////////////////////////////////////////////////////////////////////////////// 
// need to convert this from a void to a function and call it by adding
// a void main(void) { to the end of the shader
// what type of variable will the function return?, it is a color and needs to be a vec4
// change void to vec4 
//void MainImage(out vec4 fragColor, in vec2 fragCoord) 
vec4 mainImage( out vec4 fragColor, in vec2 fragCoord )
{
    // Normalized pixel coordinates (from 0 to 1)
    vec2 uv = fragCoord/iResolution.xy;
    
    uv = uv / (iMouse.x/iResolution.x + 0.5);
    
    vec2 z = vec2(iMouse.x/iResolution.x + cos(iTime/2.)*0.2 , iMouse.y/iResolution.y + sin(iTime/2.)*0.2);
    float z_2 = 0.1;
    float z_3 = iMouse.y/iResolution.y;
	float z_4 = 0.8;
	float z_5 = 0.2;
        
    // FROM NB
    vec4 f0_0=sin(uv.x*vec4(6.528,9.57,-7.2,7.948)+uv.y*vec4(-1.404,1.901,-6.232,-10.43)+z.x*vec4(6.808,-6.278,5.509,5.272)+z.y*vec4(3.706,-4.77,1.071,-2.258)+z_2*vec4(1.944,1.497,-1.335,.4379)+z_3*vec4(-9.479,5.391,-2.769,5.746)+vec4(11.52,9.856,-24.51,-4.964));
    vec4 f0_1=sin(uv.x*vec4(-9.221,-6.121,-2.939,7.257)+uv.y*vec4(4.492,2.065,.272,-5.382)+z.x*vec4(-8.453,5.66,5.371,-8.147)+z.y*vec4(-8.352,-3.415,8.655,.7186)+z_2*vec4(-1.568,3.917,2.082,-5.79)+z_3*vec4(-1.475,3.202,7.839,1.643)+vec4(16.93,17.96,-19.13,22.09));
    vec4 f0_2=sin(uv.x*vec4(2.572,-5.83,-7.572,10.16)+uv.y*vec4(3.077,-.2535,4.298,-7.276)+z.x*vec4(-8.269,5.546,8.835,3.343)+z.y*vec4(-3.994,-8.5,-.4382,1.223)+z_2*vec4(-9.598,2.292,1.406,-1.53)+z_3*vec4(-3.416,-5.205,4.672,-2.564)+vec4(22.39,-.05741,-19.97,6.218));
    vec4 f0_3=sin(uv.x*vec4(-.185,-4.58,-1.491,-9.359)+uv.y*vec4(-4.163,1.145,9.398,-9.335)+z.x*vec4(1.794,-.8057,-2.061,2.874)+z.y*vec4(7.431,-1.335,1.255,-.8926)+z_2*vec4(4.356,-2.521,.008084,7.937)+z_3*vec4(2.959,-5.742,9.169,9.956)+vec4(2.782,15.97,12.2,-12.52));
    vec4 f0_4=sin(uv.x*vec4(-1.957,1.75,-2.553,5.555)+uv.y*vec4(7.784,-1.748,-5.624,6.277)+z.x*vec4(.6851,-7.872,-9.14,-8.968)+z.y*vec4(5.88,-5.785,3.183,9.283)+z_2*vec4(-2.706,-6.754,8.304,9.47)+z_3*vec4(-8.684,-2.095,-4.088,5.862)+vec4(22.8,-10.83,13.28,-16.2));
    vec4 f1_0=sin(mat4(.4553,.1308,-.2878,-.03688,.1167,.1152,-.1517,-.1007,-.256,.4747,-.6549,.0602,-.007313,.3484,.6278,-.4176)*f0_0+
        mat4(.2125,.03737,.4449,.02829,.2587,-.1469,-.4221,-.08594,.5478,.3628,-.353,.1653,-.1005,-.2346,-.1026,-.2632)*f0_1+
        mat4(-.09219,-.07746,.3037,.03672,.1537,.09793,-.1056,.03766,.1914,.5632,-.3111,-.1147,-.5171,-.2724,-.1595,.1394)*f0_2+
        mat4(-.00431,.2222,-.579,-.1182,-.05203,.1542,-.3306,.01838,.3779,-.2747,.3465,.06113,.1214,-1.225,-.2816,1.135)*f0_3+
        mat4(-.08266,.0002591,.2888,-.2653,.09042,.2185,.3365,-.06553,-.5473,-.01568,-.09613,.1758,.1296,-.1285,.1967,-.02107)*f0_4+
        vec4(4.183,6.026,6.767,-9.613));
    vec4 f1_1=sin(mat4(.2115,.2133,-.453,.01785,.4421,-.03655,-.5639,-.03708,.4042,-.2412,.8459,-.1226,.2451,.6074,.2486,-.4027)*f0_0+
        mat4(-.1864,-.4145,.5002,.1403,-.443,-.2816,-.538,.06266,-.06869,-.1053,-.3738,.2567,-.01376,-.1912,.6242,-.1915)*f0_1+
        mat4(.3144,-.3176,-.283,-.3328,-.419,-.04762,.3891,.3686,-.6096,-.2747,-.2894,.4812,.2981,-.1171,.3005,-.4102)*f0_2+
        mat4(-.4113,-.2535,.03715,.009244,-.08491,.1098,.372,-.1487,-.05987,.307,.4896,-.04772,.4745,1.211,.1243,.1643)*f0_3+
        mat4(-.2895,-.0003279,.5292,.3682,-.1461,.1383,.2673,.1951,.0005017,.1671,-.5339,.04584,-.4984,-.02178,.0705,.1408)*f0_4+
        vec4(-10.28,7.39,-9.281,1.659));
    vec4 f1_2=sin(mat4(-.08044,-.3326,-.1516,.1701,.3774,-.8388,.001706,-.01677,-.3103,.8463,-.2726,.07321,-.1812,.2049,-.2802,.2108)*f0_0+
        mat4(-.1511,.1469,.3836,.02902,.1631,-.6253,-.03912,-.1952,.3567,-.2593,-.01064,.02922,.01451,.3834,-.1272,.02178)*f0_1+
        mat4(.0336,-.2807,-.137,-.1209,-.101,.1761,.1495,-.04785,-.9963,.3004,-.1664,.9134,-.3444,.8529,.06011,-.0858)*f0_2+
        mat4(-.2541,-.4859,.04903,-.116,.04561,.158,-.2305,-.1647,-.1745,.3405,.1853,.3712,.8791,-.2059,.8445,-1.134)*f0_3+
        mat4(-.01512,.3597,.08327,-.178,-.02736,.1221,-.01969,.1101,-.1514,.06265,-.3664,-.3242,-.08959,.07751,.3714,.01593)*f0_4+
        vec4(2.865,11.01,2.809,-13.04));
    vec4 f1_3=sin(mat4(.06768,-.05759,.1878,.05569,-.2696,.2078,-.9643,-.02264,-.326,-.2028,-.2443,.347,.4499,.4719,.3385,-.3976)*f0_0+
        mat4(-.0111,-.01237,-.1511,-.279,.2091,.1185,.1958,.2493,-.08333,-.2862,.211,-.2307,-.06193,.01926,-.1522,.2841)*f0_1+
        mat4(.03318,.295,-.1595,-.1034,.1392,-.2159,.4241,-.08525,-.08782,.6855,-.4899,.1227,-.02091,.1325,-.2468,.2302)*f0_2+
        mat4(.004109,-9.101e-05,.3943,.03009,-.01321,-.06385,.01891,.08031,-.1907,-.08962,.06838,-.08875,.8155,-1.295,-.4763,.4939)*f0_3+
        mat4(.1473,-.09949,.4568,.1936,-.1492,.01975,.2809,.07298,.07788,.2438,-.1758,-.1413,-.0002627,.1485,.1382,.4371)*f0_4+
        vec4(11.33,-12.85,-10.68,3.093));
    vec4 f1_4=sin(mat4(-.02019,.2927,.4071,.09185,.3254,.2933,.5035,-.9187,.0456,-.1176,.3017,-.3773,.3258,-.2478,-.6708,-.3761)*f0_0+
        mat4(-.1059,.1095,.1106,-.01874,.0603,.07746,.09963,-.107,-.07192,.04458,-.04441,-.285,.05509,-.272,.2959,-.5904)*f0_1+
        mat4(.05611,.1707,.4785,.1724,-.02068,.2133,-.03626,-.2189,.5809,.6753,.4963,.1564,.167,-.07923,.4974,-.4797)*f0_2+
        mat4(.2969,.3138,.1101,-.234,-.1571,-.1139,.2971,-.5258,.1418,-.2757,.05065,.2231,-1.405,-.952,.05957,.0856)*f0_3+
        mat4(.04397,-.1116,-.003114,.1971,-.01802,-.02201,.1163,.4075,-.09487,.09507,.2605,-.1267,.245,.4306,-.07512,-.07441)*f0_4+
        vec4(2.511,.297,5.4,11.91));
    vec4 f2_0=sin(mat4(-.1758,.01582,.1442,-.2567,-.03025,-.357,-.1231,.4792,-.2146,-.2806,.03352,.4196,.6741,-.4294,.02198,.76)*f1_0+
        mat4(-.2054,.1903,-.204,.3535,-.4101,.329,.1275,-.3138,-.04725,.1774,-.02848,-.01979,-.02979,-.1184,-.09737,.004433)*f1_1+
        mat4(.4676,.2953,-.6144,.9933,-.2293,-.1508,.4175,.1851,.4244,-.4948,.09994,.5989,-.1235,-.2392,-.2782,.5978)*f1_2+
        mat4(.2401,.2181,-.5016,-.3994,.2999,-.1559,-.5902,1.022,-.1843,-.05639,.3545,-.2884,-.1739,-.1198,.145,.07352)*f1_3+
        mat4(-.5494,.5143,.0808,-.7875,.4788,-.1226,-.4957,.6018,.05338,.06782,-.4647,-.1858,.3247,.1802,-.2224,-.3097)*f1_4+
        vec4(3.295,-2.201,-9.079,-8.778));
    vec4 f2_1=sin(mat4(.09398,.01577,.06058,-.223,-.1334,-.1819,-.1231,.1079,-.08053,-.1608,.377,.2284,-.4475,-.4632,-.6415,.03987)*f1_0+
        mat4(.01891,-.1817,-.003662,.192,-.05596,-.1723,.4003,.0001696,-.02022,.06912,-.1733,.04567,-.5029,-.3473,.01349,.4202)*f1_1+
        mat4(-.1918,-.01266,-.1309,.4556,.2445,-.2723,.1636,.2283,-.03078,-.1218,.1113,.07495,.1371,-.6622,-.4337,.2878)*f1_2+
        mat4(.417,.3308,.4305,-.4482,-.3493,-.7608,-.6286,.6024,-.1722,.1816,.3313,-.1918,-.1618,.1223,-.0982,-.2804)*f1_3+
        mat4(-.1328,.4924,.4342,.2836,.03615,-.2233,-.4104,.4096,-.1032,.4964,-.4919,-.1906,.02048,.2986,.09997,-.2346)*f1_4+
        vec4(-.8352,10.79,8.878,9.114));
    vec4 f2_2=sin(mat4(.1292,-.1834,-.4742,-.3997,.4921,-.14,-.2404,-.04357,-.1472,.2624,-.1366,-.5374,.2314,.3015,-.7825,-.5433)*f1_0+
        mat4(.3634,.02732,-.2127,-.08023,-.008073,.1158,.1938,-.6149,-.08059,.1944,.1999,.3804,-.0681,-.01914,-.02625,.2159)*f1_1+
        mat4(.6453,-.08542,.09079,.6337,-.3744,.3351,.1259,-.2261,-.142,.1209,-.3429,-.1942,.298,.03316,-.3745,-.1085)*f1_2+
        mat4(.003043,-.3483,.1825,.3189,.2424,.1187,-.1269,-.1013,.1313,.03937,-.1593,-.185,.1529,-.3569,-.2459,-.1132)*f1_3+
        mat4(-.4249,-.06599,.4973,.4723,.1921,-.07792,-.5683,.5456,.1669,-.1886,.04902,.4554,.3263,-.2587,-.229,.4973)*f1_4+
        vec4(6.957,4.177,-9.02,.824));
    vec4 f2_3=sin(mat4(.2703,-.261,.1619,-.01874,.7119,-.4352,-.1689,-.3747,.2507,.03411,-.2141,-.3533,-.01759,-.1193,-.4846,-.6486)*f1_0+
        mat4(.0519,-.1637,.2091,-.1192,.1652,-.2351,-.5097,.1245,.3208,-.009446,.3213,-.03348,.4749,.2235,-.3244,-.3233)*f1_1+
        mat4(.6399,-.1094,-.2287,-.3739,-.1481,-.1687,-.065,-.144,-.07579,.08469,-.07857,-.1297,.3359,-.09387,.2379,-.00192)*f1_2+
        mat4(.6193,-.04922,-.2408,.1835,.5365,-.03908,-.4251,-.317,-.0297,.09088,-.1081,.04686,.2323,.2052,-.03406,.0518)*f1_3+
        mat4(.05368,-.05515,.3514,.6334,.3096,.128,.1042,.01253,.1849,-.06635,.5634,.2854,.3003,-.1837,.5412,-.03183)*f1_4+
        vec4(4.288,7.175,-7.938,-9.226));
    vec4 f2_4=sin(mat4(-.09015,-.2095,-.2145,.03617,-.4951,.2636,-.2426,-.2411,-.3546,.1936,-.2325,-.03064,-.6931,.358,-.6443,.7965)*f1_0+
        mat4(.2134,.1671,-.1715,.2664,.2038,.2899,-.2587,.03876,-.1043,-.05713,-.06877,-.05534,-.5089,.1427,-.1573,-.1574)*f1_1+
        mat4(-.3627,-.01224,-.1714,-.0225,.1766,.5224,-.3429,.1803,-.1394,.4272,.1384,.4137,.1793,.7692,.1949,.2897)*f1_2+
        mat4(.5245,.3754,.4144,-.6159,-.274,.7814,-.3657,.02181,.1482,-.02626,-.1329,.1244,.2149,.2005,-.182,.3071)*f1_3+
        mat4(.2919,-.5661,.1294,.004804,-.4697,.3816,-.2035,.08656,.03878,-.227,.3908,-.01246,-.04701,-.3305,.3616,-.1359)*f1_4+
        vec4(-3.418,-12.05,-10.67,3.835));
    vec4 f3_0=sin(mat4(-.9014,-.5287,.4909,.3349,-.07517,-.06559,-.4956,.5957,-.2183,.01573,-.3224,.1924,-1.163,1.066,-.3281,.1677)*f2_0+
        mat4(.2931,.3713,-.08589,.04946,.2764,.5163,-.3996,.3795,.9896,-.1777,.05867,-.5155,-1.147,.7053,.02943,.3196)*f2_1+
        mat4(.9789,-.6286,.3855,-.3254,.4102,-.1957,-.2576,.3917,.4261,.14,.04798,.6797,-.1816,-.3396,.07975,-.4325)*f2_2+
        mat4(-.4199,-.006095,.1638,.4733,-.5998,-.02976,-.231,.1186,-.0158,.3255,-.09909,.7565,.7268,-.2294,-.112,-.2703)*f2_3+
        mat4(.5982,-.5236,.2351,-.3373,.9274,-.5823,.3707,-.2595,.1493,-.4409,.06298,-.3994,-.4068,.6454,.01472,.502)*f2_4+
        vec4(.3207,-11.09,-8.542,8.862));
    vec4 f3_1=sin(mat4(-.03922,-.5138,-.2613,.4074,-.5869,.03816,-.3338,-.01861,-.2798,-.183,-.1263,-.4076,-.2192,-1.055,-.08364,-.5757)*f2_0+
        mat4(-.1833,.01988,.176,.03964,-.04918,.2581,-.1333,-.3953,.2975,.3433,.01052,-.2642,.3701,-.1335,.03922,-.1201)*f2_1+
        mat4(.157,.4503,.1508,-.03036,.1192,-.1791,-.5896,.3236,-.1135,.1291,-.198,-.1386,-.4941,-.3521,-.1717,-.4076)*f2_2+
        mat4(-.197,-.06716,-.05452,.03934,-.1652,.06245,.576,-.1592,.3953,.2953,.04795,-.06502,-.012,.2658,.07885,-.5869)*f2_3+
        mat4(.1944,-.01574,-.2622,.5185,.3835,.3434,-.03127,-.4766,-.1653,-.3019,.07062,.1133,.3135,-.2799,-.1943,-.02792)*f2_4+
        vec4(1.518,2.71,9.459,6.929));
    vec4 f3_2=sin(mat4(-.6256,-.1038,.3071,-.2162,.225,-.5841,.03761,.5222,.4631,.1572,-.4488,.3319,-.03535,.08278,.1603,.1452)*f2_0+
        mat4(.639,-.2891,.3288,.4581,.8377,.02612,-.01161,.5695,.1857,.06882,-.004221,-.08902,-.1918,.1562,.5994,-.2378)*f2_1+
        mat4(.2517,-.2362,-.1795,.1261,.6795,-.0964,.325,.4484,.4013,.2312,-.1435,.2137,-.6049,.2325,-.6516,.3762)*f2_2+
        mat4(-.1269,-.09588,-.09735,-.1752,-.6008,.2734,-.3043,-.07307,.751,-.3035,-.07399,.04265,.6021,-.1911,.4346,-.2491)*f2_3+
        mat4(.1909,.3391,-.08458,-.368,-.02271,.2579,-.4425,-.08933,-.3048,-.3286,-.5219,-.4075,-.1324,-.2445,.6708,.7637)*f2_4+
        vec4(-7.285,-2.599,-1.171,-12.79));
    vec4 f3_3=sin(mat4(-.6714,.1103,.1445,.2091,.0782,-.04471,.1663,-.05506,.3007,.1059,.3456,.007481,-.9114,-.1445,.1066,.336)*f2_0+
        mat4(-.2852,-.09737,-.2103,.448,-.03609,-.04284,.2894,-.0332,.6829,.03071,.1027,.008769,-.855,.03087,.5867,.5646)*f2_1+
        mat4(1.012,.09324,-.03776,-.3278,.5019,.5866,-.4896,.5678,.2494,.1616,-.1087,.212,.1263,-.03831,-.4392,-.336)*f2_2+
        mat4(.06127,.04139,.2022,.04459,-.5782,.09268,.09194,-.5463,-.272,.2632,-.1561,.3576,.8434,.1818,-.329,-.3446)*f2_3+
        mat4(.2281,-.08844,.2732,-.2704,.7284,-.0515,-6.999e-05,-.1509,.1683,.006912,-.003645,-.1664,.2473,.04677,-.4955,.1037)*f2_4+
        vec4(-2.648,2.183,-4.972,4.715));
    vec4 f3_4=sin(mat4(-.03614,.2239,.3376,-.04151,-.1079,-.2893,-.01388,.05539,.09926,-.3318,-.4695,-.293,.1837,-.3919,-.009471,.3585)*f2_0+
        mat4(.3944,-.2894,-.2806,-.1851,-.04247,-.3089,.04222,.2911,.01489,-.1595,-.4,-.1054,.3668,.1666,.6983,.3111)*f2_1+
        mat4(-.03592,-.2556,-.4059,-.3669,-.01368,-.1105,.1654,.08496,-.2059,-.2006,-.1498,-.02038,.7609,-.2703,-.7511,-.7818)*f2_2+
        mat4(-.2068,.02471,.2056,.3104,-.4311,.2535,.18,.5266,-.5367,.09562,.4339,.01988,.1822,-.5297,-.1121,.2315)*f2_3+
        mat4(.01469,.09185,.07695,.1818,.357,-.4574,-.7134,-.2632,.2131,.00413,-.01345,.1393,.5815,-.5175,.4264,-.2145)*f2_4+
        vec4(12.49,-10.03,11.8,8.374));
    vec4 f4_0=sin(mat4(.3152,.5424,.0691,.2044,-.3833,-.2118,-.2027,-.1273,.1738,-.1721,-.08443,.01245,-.2009,-.3114,.05905,-.2807)*f3_0+
        mat4(-.1437,.4616,-.0411,-.1166,-.01983,.04802,.2519,-.2764,-.05622,.1718,-.3268,-.03243,-.6036,-.6705,-.9276,.07897)*f3_1+
        mat4(-.8541,-.6347,-.3069,-.1841,.2988,-.3547,.2528,-.4129,-.09216,.3055,.17,.2549,-.09434,-.2722,-.08767,-.05052)*f3_2+
        mat4(-.2884,-.5203,.1808,-.4905,.1572,.425,.05118,-.1151,-.2815,.4725,.2881,-.07637,.2726,.1897,.2754,.1508)*f3_3+
        mat4(.2669,.2277,.2865,.2041,.7439,.4364,.1962,.2455,-.1895,-.1719,.3389,-.5024,.4309,.09085,-.1086,.2801)*f3_4+
        vec4(2.47,.9129,8.339,-8.439));
    vec4 f4_1=sin(mat4(.3172,.3497,-.5876,.3165,-1.12,-.2713,.656,-.01407,-.1761,.3621,-.04878,.4138,-.7353,-.3015,.494,-.1601)*f3_0+
        mat4(-.1809,-.0006368,-.1129,.07064,-.4166,-.5197,.08565,.2318,.07104,-.3942,.2204,.06925,-.06272,.8485,.2883,-.5367)*f3_1+
        mat4(-.458,.3612,.5483,-.3026,-.08304,-.1558,.2332,-.2565,.4455,.255,-.5543,.07615,-.3106,-.4423,.002291,-.3142)*f3_2+
        mat4(-.2667,-.7655,.02196,.06791,-.007514,.1125,.3445,-.2292,-.1656,.08691,.3055,-.5113,.3082,-.132,-.5361,-.1387)*f3_3+
        mat4(.2267,.08661,-.1738,-.2829,.388,-.7047,-.7433,.6324,.308,-.5392,.08525,.5684,.2183,.5435,-.3954,.08546)*f3_4+
        vec4(-5.14,-10.25,1.681,3.531));
    vec4 f4_2=sin(mat4(.05813,.2475,-.345,.3039,.298,.1677,.1786,.1914,.04122,.5303,-.2752,.2288,.3192,-.00187,-.172,-.1298)*f3_0+
        mat4(-.4576,-.3026,.5121,-.3154,.5334,-.115,-.238,-.1237,.09361,.1231,-.2287,-.1431,-.2765,.2183,.4859,-.5159)*f3_1+
        mat4(.001283,-.4451,.2149,-.3035,.4841,.7257,.111,-.5156,.04364,.2315,-.2358,.7482,.3225,-.04,-.1116,-.01748)*f3_2+
        mat4(-.2014,-.3948,.2255,-.7505,-.3405,-.4217,.5453,.6006,-.2829,.3316,-.003535,.573,-.4176,.5236,-.2974,.761)*f3_3+
        mat4(.0111,.2367,-.6412,.3028,.1817,.4156,-.02857,.8504,.2375,-.5371,-.007075,-.1474,-.1235,.1825,-.349,.4478)*f3_4+
        vec4(7.564,-12.94,-6.235,1.297));
    vec4 f4_3=sin(mat4(.4122,.3522,-.3484,-.6489,-.7699,-.2709,.3527,.04158,-.1835,.4603,.2459,.02086,-.4994,-.2963,.4895,.1379)*f3_0+
        mat4(-.7688,.1268,.525,.411,.00961,-.3647,.1776,.3908,.08894,.2156,-.1767,-.467,-.2891,-.1305,.137,.6868)*f3_1+
        mat4(-.6071,-.3751,.1309,.2102,.2719,-.07424,-.7616,.05415,.3332,.574,-.188,-.811,-.1126,-.233,.01795,-.4228)*f3_2+
        mat4(.04837,-.2936,.4749,.04858,-.7961,.3749,.5771,.3144,-.1041,-.03545,-.2255,.3653,.1631,.6156,-.3951,-.911)*f3_3+
        mat4(.1656,.1748,-.2347,-.3933,.7353,.6051,.4707,-.7351,.2167,.0266,-.08847,.3673,-.009459,.563,-.5039,-.3604)*f3_4+
        vec4(12.65,11.03,-5.129,-3.495));
    vec4 f4_4=sin(mat4(.5591,.43,-.4642,-.173,-.4997,-.3847,.08251,.3867,-.287,.4103,-.577,.2326,-.2632,-.4171,.1169,.07755)*f3_0+
        mat4(-.4545,-.4998,.5105,-.1096,-.1067,-.4095,.2665,-.2307,.3074,.4306,-.2002,-.1131,-.4324,-.6491,.1132,.5024)*f3_1+
        mat4(-.1512,-.202,.02619,.2182,.3615,.708,.0382,.06751,.1976,.4835,-.5701,-.2464,-.2889,.3767,-.5378,-.02563)*f3_2+
        mat4(-.1836,.01437,.1442,-.02447,.04222,-.4972,.854,-.2464,.4735,-.02152,.3292,.2098,.2046,.6041,-.8209,.3562)*f3_3+
        mat4(.3783,.1488,-.2444,-.1621,.204,.5336,-.5119,-.1867,.4411,.07987,.5155,-.8259,.4508,.4544,-.2755,.06829)*f3_4+
        vec4(-10.39,-5.6,9.657,-9.101));
    float r=dot(f4_0,vec4(-.02058,-.01851,-.02044,-.008273))+
        dot(f4_1,vec4(-.01898,.02518,-.01988,-.02765))+
        dot(f4_2,vec4(-.008072,-.004271,-.005443,-.02021))+
        dot(f4_3,vec4(.01854,.01985,.005059,.01917))+
        dot(f4_4,vec4(-.02128,.01994,-.0007178,.02441))+
        0.431;
    float g=dot(f4_0,vec4(-.007226,-.007261,-.0003696,.01541))+
        dot(f4_1,vec4(-.001992,.003654,-.003528,.002501))+
        dot(f4_2,vec4(.02171,.02147,-.01866,-.001849))+
        dot(f4_3,vec4(.003793,.004337,-.01666,.002656))+
        dot(f4_4,vec4(-.00977,.006472,.02099,-.004626))+
        0.468;
    float b=dot(f4_0,vec4(.0006063,.0004519,.01534,.01725))+
        dot(f4_1,vec4(-.001965,.001568,.0001938,.01618))+
        dot(f4_2,vec4(.007435,.01347,.002058,-.01258))+
        dot(f4_3,vec4(-.004673,.00521,-.01949,.006444))+
        dot(f4_4,vec4(.004651,.001084,.01332,-.01457))+
        0.397;
    

    // Time varying pixel color
    vec3 col = vec3(r, g, b);

    // Output to screen
    fragColor = vec4(col,1.0);
/////////////////////////////////////////////////////////////////////////////////
//the function needs to return a value. 
//it needs to be a vec4
//we will return the varable fragColor 
// usual place for fragColor = vec4( color, 1.0 ); bring the } down below
return fragColor; 
}

///////////////////////////////////////////////////////////////////////////////// 
void main(void) { // this will be run for every pixel of gl_FragCoord.xy
vec4 fragColor = vec4(1.0); // initialize variable fragColor as a vec4 
vec4 cc = mainImage(fragColor, gl_FragCoord.xy); // call function mainImage and assign the return vec4 to cc
gl_FragColor = vec4(cc) * gl_Color; // set the pixel to the value of vec4 cc  and..
}

// ..uses the values of any Color: or Opacity:
// clauses (and any Animate clauses applied to these properties) 
// appearing in the Sprite, Quad or other node invoking the shader 
// in the .scn file.

